<?php /* BISMILLAHIRRAHMANIRRAHEEM */

//-- Configurations:
$filehouseslist = "houseslist.txt";
$fdelimiter = "*|*";
$filehouseprefix = "house";	// For example: $filehouseprefix . $filehousesuffix is "house.txt" or "house"[HID]".txt"
$filehousesuffix = ".txt";		// Script generates file names for houses "house1.txt", "house2.txt" etc
header('Content-Type: application/json; charset=utf-8');
$jdata = json_decode(file_get_contents('php://input'), true); // JSON data, parse into $jdata array, can check by print_r($jdata) INSHAALLAH

//$ret["status"] = ""; // status, true on success, false on failure/ error
$ret["Action"] = $jdata["Action"]; // returns the Action/ Action code, same as request
//$ret["data"] = ""; // contains payload/ return data
//$ret["message"] = ""; // contains error message, if any
if (array_key_exists("HID", $jdata)) {
	$jdata["HID"] = intval($jdata["HID"]);
}
$ret["message"] = "";

if ($jdata["Action"] == "SaveHouse") {
	try {
		/*
			$f					file (handle)
			$fcontents		file contents
			$fline			file line (current line being read)
			$flcount			file line count (file contents line count)
		*/
		$filename = $filehouseslist;
		//$file = join(DIRECTORY_SEPARATOR, array('textdata', $filename));
		$file = join(DIRECTORY_SEPARATOR, array('textdata', $filename));
		$f = fopen($file, "a+");// or die("Unable to open file: " . $file . "<br />Please check directory/ file permissions");
		if (!$f) {
			throw new Exception("Could not open house file: " . basename($file) . "<br />Please check directory/ file permissions");
		}
		$houseslist = [];
		$HID = 0;
		$i = 0;
		$hidlist = [];
		$freehid = 0; // Free HID, if any... used to look for gaps in HIDs, for example: If House IDs are [1,2,4], "3" is HID we can use for new House entry.
		$prevhid = 0; // Previous HID
		if (filesize($file) > 0) {
			rewind($f); // just in case
			//$fcontents = fread($f,filesize);
			rewind($f);
			while ($fline = trim(fgets($f))) {
				if ($fline != "") {
					$house = explode($fdelimiter, $fline);
					if ((count($house) == 2) && (intval($house[0]) > 0)) { // HID must be greater than 0
						$houseslist[$i]["HID"] = $house[0];
						//$houseslist[$i]["House"] = $house[1];
						if (($house[0] == $jdata["HID"]) && (trim($house[1]) == trim($jdata["House"]))) { // Entry exists, then edit (not add new entry)
							$HID = $house[0];
							$houseslist[$i]["House"] = $jdata["House"];
						} else {
							$houseslist[$i]["House"] = $house[1];
						}
						array_push($hidlist, $house[0]);
						$i = $i + 1;
						if ($freehid == 0) { // Still not found empty HID slot
							if (($house[0] - $prevhid) > 1) { // Should be equal, for consecutively increasing HIDs, if difference > 1, there is gap
								$freehid = $prevhid + 1;
							}
							$prevhid = $house[0];
						}
					} /*else {
						throw new Exception("Incorrect house list data format. File: " . basename($file) . " is not in correct format. Correct format:<br />ID (int)" . $fdelimiter . "House name (string)");
					}*/
				}
			}
		}
		$house = [];
		fclose($f); // ALHAMDOLILLAH houses list loaded
		if ($HID == 0) { // No match found, add new House INSHAALLAH ALHAMDOLILLAH
			if ($jdata["HID"] > 0) {
				$jdata["HID"] = -1;
			}
			if ($freehid == 0) {
				if ($i > 0) {
					$freehid = max($hidlist) + 1; // Couldn't find free HID, so take the maximum HID already assigned to house and increment by 1.
				} else {
					$freehid = 1;
				}
			}
			$HID = $freehid;
			$houseslist[$i]["HID"] = $freehid;
			$houseslist[$i]["House"] = $jdata["House"];
		}
		// Write houses file
		$f = fopen($file, "w");
		if (!$f) {
			throw new Exception("Could not open house file: " . basename($file) . "<br />Please check directory/ file permissions.");
		}
		foreach($houseslist as $h) {
			fputs($f, $h["HID"] . $fdelimiter . $h["House"] . "\r\n");
		}
		fclose($f);
		// Write patients file
		$filename = $filehouseprefix . $HID . $filehousesuffix;
		$file = join(DIRECTORY_SEPARATOR, array('textdata', $filename));
		$f = fopen($file, "w");
		if (!$f) {
			throw new Exception("Could not open patients file: " . basename($file) . "<br />Please check directory/ file permissions.");
		}
		foreach($jdata["Patients"] as $p) {
			fputs($f, trim($p) . "\r\n");
		}
		fclose($f);
		//if (($jdata["HID"] > 0) && ($jdata["HID"] != $HID)) { // HID was not found, so added new entry ALHAMDOLILLAH
		if ($jdata["HID"] == -1) { // HID was not found, so added new entry ALHAMDOLILLAH
			//$ret["message"] = "House was not found. Added new House entry.";
			$ret["message"] = "Saved successfully.";
		} else {
			$ret["message"] = "Saved successfully.";
		}
		$ret["status"] = true;
		$ret["data"] = $jdata["House"];
	}
	catch (Exception $e) {
		$ret["status"] = false;
		$ret["message"] = "PHP Exception:<br />
		<div class=\"table\">
			<div class=\"rowsimple\">
				<div class=\"colerrorcategory\">File:</div>
				<div class=\"colerrordetails\">" . basename($e->getFile()) . "</div>
			</div>
			<div class=\"rowsimple\">
				<div class=\"colerrorcategory\">Line:</div>
				<div class=\"colerrordetails\">" . $e->getLine() . "</div>
			</div>
			<div class=\"rowsimple\">
				<div class=\"colerrorcategory\">Message:</div>
				<div class=\"colerrordetails\">" . $e->getMessage() . "</div>
			</div>
		</div>";
	}
	
}

if ($jdata["Action"] == "LoadHousesList") {
	try {
		$filename = $filehouseslist;
		$file = join(DIRECTORY_SEPARATOR, array('textdata', $filename));
		$f = fopen($file, "a+");
		if (!$f) {
			throw new Exception("Could not open file: " . basename($file) . "<br />Please check directory/ file permissions");
		}
		$houseslist = [];
		$i = 0;
		if (filesize($file) > 0) {
			rewind($f);
			while ($fline = trim(fgets($f))) {
				if ($fline != "") {
					$house = explode($fdelimiter, $fline);
					if ((count($house) == 2) && (intval($house[0]) > 0)) { // HID must be greater than 0
						$houseslist[$i]["HID"] = $house[0];
						$houseslist[$i]["House"] = $house[1];
						$i = $i + 1;
					} /*else {
						throw new Exception("Incorrect house list data format. File: " . basename($file) . " is not in correct format. Correct format:<br />ID (int)" . $fdelimiter . "House name (string)");
					}*/
				}
			}
		}
		fclose($f);

		$ret["status"] = true;
		$ret["message"] = "ALHAMDOLILLAH houses list loaded successfully.";
		$ret["data"] = $houseslist;

	}
	catch (Exception $e) {
		$ret["status"] = false;
		$ret["message"] = "PHP Exception:<br />
		<div class=\"table\">
			<div class=\"rowsimple\">
				<div class=\"colerrorcategory\">File:</div>
				<div class=\"colerrordetails\">" . basename($e->getFile()) . "</div>
			</div>
			<div class=\"rowsimple\">
				<div class=\"colerrorcategory\">Line:</div>
				<div class=\"colerrordetails\">" . $e->getLine() . "</div>
			</div>
			<div class=\"rowsimple\">
				<div class=\"colerrorcategory\">Message:</div>
				<div class=\"colerrordetails\">" . $e->getMessage() . "</div>
			</div>
		</div>";
	}
	
}



if ($jdata["Action"] == "EditHouse") {
	try {
		$filename = $filehouseslist;
		$file = join(DIRECTORY_SEPARATOR, array('textdata', $filename));
		$f = fopen($file, "a+");
		if (!$f) {
			throw new Exception("Could not open file: " . basename($file) . "<br />Please check directory/ file permissions");
		}
		$houseslist = [];
		$i = 0;
		if (filesize($file) > 0) {
			rewind($f);
			while ($fline = trim(fgets($f))) {
				if ($fline != "") {
					$house = explode($fdelimiter, $fline);
					if ((count($house) == 2) && (intval($house[0]) > 0)) { // HID must be greater than 0
						$houseslist[$i]["HID"] = $house[0];
						$houseslist[$i]["House"] = $house[1];
						$i = $i + 1;
					} /*else {
						throw new Exception("Incorrect house list data format. File: " . basename($file) . " is not in correct format. Correct format:<br />ID (int)" . $fdelimiter . "House name (string)");
					}*/
				}
			}
		}
		fclose($f);
		$house = null;
		$house["HID"] = 0;
		$house["House"] = "";
		$house["Patients"] = "";
		foreach($houseslist as $h) {
			if ($h["HID"] == $jdata["HID"]) {
				$house["HID"] = $h["HID"];
				$house["House"]  = $h["House"];
			}
		}
		if ($house["HID"] > 0) {
			$filename = $filehouseprefix . $house["HID"] . $filehousesuffix;
			$file = join(DIRECTORY_SEPARATOR, array('textdata', $filename));
			if (file_exists($file)) {
				$f = fopen($file, "a+");
				if (!$f) {
					throw new Exception("Could not open patients file: " . basename($file) . "<br />Please check directory/ file permissions");
				}
				//$fs = filesize($file);
				if (filesize($file) > 0) {
					rewind($f);
					while ($fline = trim(fgets($f))) {
						if ($house["Patients"] == "") {
							$house["Patients"] = $house["Patients"] . $fline;
						} else {
							$house["Patients"] = $house["Patients"] . "
" . $fline;
						}
					}
				}
				/*if ($fs > 0) {
					rewind($f); // just in case
					//$house["Patients"] = fread($f, $fs);
				}*/
				fclose($f);
			}
			$ret["status"] = true;
			$ret["message"] = "ALHAMDOLILLAH house data fetched successfully for edit.";
		} else {
			$ret["status"] = false;
			$ret["message"] = "Invalid House ID. House not found.";
		}
		$ret["data"] = $house;
	}
	catch (Exception $e) {
		$ret["status"] = false;
		$ret["message"] = "PHP Exception:<br />
		<div class=\"table\">
			<div class=\"rowsimple\">
				<div class=\"colerrorcategory\">File:</div>
				<div class=\"colerrordetails\">" . basename($e->getFile()) . "</div>
			</div>
			<div class=\"rowsimple\">
				<div class=\"colerrorcategory\">Line:</div>
				<div class=\"colerrordetails\">" . $e->getLine() . "</div>
			</div>
			<div class=\"rowsimple\">
				<div class=\"colerrorcategory\">Message:</div>
				<div class=\"colerrordetails\">" . $e->getMessage() . "</div>
			</div>
		</div>";
	}
	
}

if ($jdata["Action"] == "DeleteHouse") {
	try {
		$filename = $filehouseslist;
		$file = join(DIRECTORY_SEPARATOR, array('textdata', $filename));
		$f = fopen($file, "a+");
		if (!$f) {
			throw new Exception("Could not open file: " . basename($file) . "<br />Please check directory/ file permissions");
		}
		$houseslist = [];
		$HID = 0;
		$i = 0;
		$jdata["House"] = "";
		if (filesize($file) > 0) {
			rewind($f);
			while ($fline = trim(fgets($f))) {
				if ($fline != "") {
					$house = explode($fdelimiter, $fline);
					if ((count($house) == 2) && (intval($house[0]) > 0)) { // HID must be greater than 0
						if ($house[0] == $jdata["HID"]) {
							$HID = $house[0];
							$jdata["House"] = $house[1];
						} else {
							$houseslist[$i]["HID"] = $house[0];
							$houseslist[$i]["House"] = $house[1];
							$i = $i + 1;
						}
					} /*else {
						throw new Exception("Incorrect house list data format. File: " . basename($file) . " is not in correct format. Correct format:<br />ID (int)" . $fdelimiter . "House name (string)");
					}*/
				}
			}
		}
		fclose($f);
		// Write houses file
		$f = fopen($file, "w");
		if (!$f) {
			throw new Exception("Could not open house file: " . basename($file) . "<br />Please check directory/ file permissions.");
		}
		foreach($houseslist as $h) {
			fputs($f, $h["HID"] . $fdelimiter . $h["House"] . "\r\n");
		}
		fclose($f);
		// Delete patients file
		$filename = $filehouseprefix . $HID . $filehousesuffix;
		$file = join(DIRECTORY_SEPARATOR, array('textdata', $filename));
		$ret["message"] = "";
		if (file_exists($file)) {
			if (!unlink($file)) {
				$ret["message"] = "<br />Failed to delete Patients file: " . $file;
			}
		}
		if ($HID != $jdata["HID"]) { // HID was not found, AOOZOBILLAH
			$ret["status"] = false;
			$ret["message"] = "House was not found. Delete operation not performed.";
		} else {
			$ret["status"] = true;
			$ret["message"] = "ALHAMDOLILLAH house deleted successfully." . $ret["message"];
		}
		$ret["data"] = $jdata["House"];
	}
	catch (Exception $e) {
		$ret["status"] = false;
		$ret["message"] = "PHP Exception:<br />
		<div class=\"table\">
			<div class=\"rowsimple\">
				<div class=\"colerrorcategory\">File:</div>
				<div class=\"colerrordetails\">" . basename($e->getFile()) . "</div>
			</div>
			<div class=\"rowsimple\">
				<div class=\"colerrorcategory\">Line:</div>
				<div class=\"colerrordetails\">" . $e->getLine() . "</div>
			</div>
			<div class=\"rowsimple\">
				<div class=\"colerrorcategory\">Message:</div>
				<div class=\"colerrordetails\">" . $e->getMessage() . "</div>
			</div>
		</div>";
	}
	
}



if ($jdata["Action"] == "LoadPatientsList") { // Same code as "EditHouse" ALHAMDOLILLAH
	try {
		$filename = $filehouseslist;
		$file = join(DIRECTORY_SEPARATOR, array('textdata', $filename));
		$f = fopen($file, "a+");
		if (!$f) {
			throw new Exception("Could not open file: " . basename($file) . "<br />Please check directory/ file permissions");
		}
		$houseslist = [];
		$i = 0;
		if (filesize($file) > 0) {
			rewind($f);
			while ($fline = trim(fgets($f))) {
				if ($fline != "") {
					$house = explode($fdelimiter, $fline);
					if ((count($house) == 2) && (intval($house[0]) > 0)) { // HID must be greater than 0
						$houseslist[$i]["HID"] = $house[0];
						$houseslist[$i]["House"] = $house[1];
						$i = $i + 1;
					} /*else {
						throw new Exception("Incorrect house list data format. File: " . basename($file) . " is not in correct format. Correct format:<br />ID (int)" . $fdelimiter . "House name (string)");
					}*/
				}
			}
		}
		fclose($f);
		$house = null;
		$house["HID"] = 0;
		$house["House"] = "";
		$house["Patients"] = [];
		foreach($houseslist as $h) {
			if ($h["HID"] == $jdata["HID"]) {
				$house["HID"] = $h["HID"];
				$house["House"]  = $h["House"];
			}
		}
		if ($house["HID"] > 0) {
			$filename = $filehouseprefix . $house["HID"] . $filehousesuffix;
			$file = join(DIRECTORY_SEPARATOR, array('textdata', $filename));
			if (file_exists($file)) {
				$f = fopen($file, "a+");
				if (!$f) {
					throw new Exception("Could not open patients file: " . basename($file) . "<br />Please check directory/ file permissions");
				}
				$fs = filesize($file);
				if ($fs > 0) {
					rewind($f); // just in case
					//$patientslist = fread($f, $fs);					
					$i = 0;
					while ($fline = trim(fgets($f))) {
						if ($fline != "") {
							$patientslist[$i] = $fline;
							$i = $i + 1;
						}
					}
					$i = 0;
					foreach($patientslist as $p) {	//026391  Biehler, Torsten, 16.05.1939
						$pat = explode(" ", $p);
						// $pat[0] = 026391
						// $pat[1] = Biehler, Torsten, 16.05.1939
						/*if (!(count($pat) == 2)) {
							throw new Exception("Incorrect patients list data format. File: " . basename($file) . " is not in correct format. Correct format:<br />PID{space}PatientLastName,{space}PatientFirstName,{space}dd.mm.yyyy");
						}*/
						$pid = $pat[0];
						/*
						// Name etc verification starts
						$pdata = explode(" ", $pat[1]);
						// $pdata[0] = Biehler,
						// $pdata[1] = Torsten,
						// $pdata[2] = 16.05.1939
						if (!(count($pdata) == 3)) {
							throw new Exception("Incorrect patients list data format. File: " . basename($file) . " is not in correct format. Incorrect name and date format. Correct format:<br />PatientLastName,{space}PatientFirstName,{space}dd.mm.yyyy");
						}
						$plname = trim(str_replace(",", " ", $pdata[0]));	// To replace commas within names to spaces // $plname = str_replace(",", " ", $pdata[0]);
						$pfname = trim(str_replace(",", " ", $pdata[1]));	// To replace commas within names to spaces // $pfname = str_replace(",", " ", $pdata[1]);
						$pddate = trim($pdata[2]);
						// Start date format verification - Date format dd.mm.yyyy
						
						$pdatedata = explode(".", $pddate);
						if (!(count($pdatedata) == 3)) {
							throw new Exception("Incorrect patients list data format. File: " . basename($file) . " is not in correct format. Incorrect date format. Correct format: dd.mm.yyyy");
						}
						if (!(is_numeric($pdatedata[0]) && (strlen($pdatedata[0]) == 2) && (intval($pdatedata[0]) >= 1) && (intval($pdatedata[0]) <= 31))) {
							throw new Exception("Incorrect patients list data format. File: " . basename($file) . " is not in correct format. Incorrect date format. Day must be two digits and between 1 and 31.");
						}
						if (!(is_numeric($pdatedata[1]) && (strlen($pdatedata[1]) == 2) && (intval($pdatedata[1]) >= 1) && (intval($pdatedata[1]) <= 12))) {
							throw new Exception("Incorrect patients list data format. File: " . basename($file) . " is not in correct format. Incorrect date format. Month must be two digits and between 1 and 12.");
						}
						if (!(is_numeric($pdatedata[2]) && (strlen($pdatedata[2]) == 4) && (intval($pdatedata[2]) >= 1700) && (intval($pdatedata[2]) <= 2999))) {
							throw new Exception("Incorrect patients list data format. File: " . basename($file) . " is not in correct format. Incorrect date format. Month must be two digits and between 1700 and 2999.");
						}*/
						// End date format verification
						$house["Patients"][$i]["PID"] = $pid;
						//$house["Patients"][$i]["FName"] = $pfname;
						//$house["Patients"][$i]["LName"] = $plname;
						//$house["Patients"][$i]["FullName"] = $plname . ", " . $pfname;
						//$house["Patients"][$i]["DDate"] = $pddate;
						$house["Patients"][$i]["Patient"] = $p;
						$i = $i + 1;
					}
				}
				fclose($f);
			}
			$ret["status"] = true;
			$ret["message"] = "ALHAMDOLILLAH house data fetched successfully.";
		} else {
			$ret["status"] = false;
			$ret["message"] = "Invalid House ID. House not found.";
		}
		$ret["data"] = $house;
	}
	catch (Exception $e) {
		$ret["status"] = false;
		$ret["message"] = "PHP Exception:<br />
		<div class=\"table\">
			<div class=\"rowsimple\">
				<div class=\"colerrorcategory\">File:</div>
				<div class=\"colerrordetails\">" . basename($e->getFile()) . "</div>
			</div>
			<div class=\"rowsimple\">
				<div class=\"colerrorcategory\">Line:</div>
				<div class=\"colerrordetails\">" . $e->getLine() . "</div>
			</div>
			<div class=\"rowsimple\">
				<div class=\"colerrorcategory\">Message:</div>
				<div class=\"colerrordetails\">" . $e->getMessage() . "</div>
			</div>
		</div>";
	}
	
}



if ($jdata["Action"] == "DeleteAllHouses") {
	try {
		$filename = $filehouseslist;
		$file = join(DIRECTORY_SEPARATOR, array('textdata', $filename));
		$f = fopen($file, "a+");
		if (!$f) {
			throw new Exception("Could not open file: " . basename($file) . "<br />Please check directory/ file permissions");
		}
		if (filesize($file) > 0) {
			rewind($f);
			while ($fline = trim(fgets($f))) {
				if ($fline != "") {
					$house = explode($fdelimiter, $fline);
					if ((count($house) == 2) && (intval($house[0]) > 0)) { // HID must be greater than 0 // check format HID{delimiter}HouseName, or else ignore entry
						$pfilename = $filehouseprefix . $house[0] . $filehousesuffix; // Patients file
						$pfile = join(DIRECTORY_SEPARATOR, array('textdata', $pfilename));
						if (file_exists($pfile)) {
							if (!unlink($pfile)) {
								$ret["message"] = $ret["message"] . "<br />Failed to delete Patients file: " . $file;
							}
						}
					}
				}
			}
		}
		fclose($f);
		if (file_exists($file)) {
			if (!unlink($file)) {
				$ret["message"] = "<br />Failed to delete Houses file: " . $file;
			}
		}
		$ret["data"] = "";
		if ($ret["message"] == "") {
			$ret["status"] = true;
			$ret["message"] = "ALHAMDOLILLAH list of all houses and all patients lists deleted successfully.";
		} else {
			$ret["status"] = false;
			$ret["message"] = "There were some errors while attempting to delete Houses and Patients lists:<br />" . $ret["message"];
		}
	}
	catch (Exception $e) {
		$ret["status"] = false;
		$ret["message"] = "PHP Exception:<br />
		<div class=\"table\">
			<div class=\"rowsimple\">
				<div class=\"colerrorcategory\">File:</div>
				<div class=\"colerrordetails\">" . basename($e->getFile()) . "</div>
			</div>
			<div class=\"rowsimple\">
				<div class=\"colerrorcategory\">Line:</div>
				<div class=\"colerrordetails\">" . $e->getLine() . "</div>
			</div>
			<div class=\"rowsimple\">
				<div class=\"colerrorcategory\">Message:</div>
				<div class=\"colerrordetails\">" . $e->getMessage() . "</div>
			</div>
		</div>";
	}
	
}



//echo json_encode(utf8ize($ret), JSON_FORCE_OBJECT); // Doesn't encode non-English characters without UTF-8
echo json_encode($ret, JSON_FORCE_OBJECT); // Doesn't encode non-English characters without UTF-8

// https://stackoverflow.com/questions/19361282/why-would-json-encode-return-an-empty-string
function utf8ize($d) {
	if (is_array($d)) {
		foreach ($d as $k => $v) {
			$d[$k] = utf8ize($v);
		}
	} else if (is_string ($d)) {
		return utf8_encode($d);
	}
	return $d;
}

function deutf8ize($d) {
	if (is_array($d)) {
		foreach ($d as $k => $v) {
			$d[$k] = utf8ize($v);
		}
	} else if (is_string ($d)) {
		return utf8_decode($d);
	}
	return $d;
}

?>
